%
% Convertor : XFEL EXCEL DATA -> ELEGANT LATTICE
%
% 2013.04.02 Hyunchang Jin (hyunchang.jin@desy.de)
%
% Choose SBEN (T1.BZ & TLD.BZ) settings for TD1 (TD = 1) & TD2 (TD = 2) beam-line
%
%SECTION	CADRoom	NAME1	NAME2	GROUP	CLASS	TYPE	LENGTH	STRENGTH	 E1/LAG	E2/FREQ	  TILT	S	X	Y	Z	THETA	PHI	  CHI	XPD	YPD	ZPD	THETAPD	PHIPD	CHIPD	ENERGY	BETX	ALFX	MUX	  BETY	ALFY	MUY	  DX	DPX	  DY	DPY
%[]	        []	    []	    []	    []	    []	    []	    [m]	    [m^(1-n)/MV] [rad]	[rad/MHz] [rad]	[m]	[m]	[m]	[m]	[rad]	[rad] [rad]	[m]	[m]	[m]	[rad]	[rad]	[rad]	[GeV]	[m]	    [rad]	[2PI] [m]	[rad]	[2PI] [m]	[rad] [m]	[rad]
%

clear;

[ndata, text, alldata] = xlsread('component_list_8.3.xls',2);

TD = 1; % TD = 2 for TD2 beam line

% Make lists
k1 = 1; k2 = 1;
for i = 3:length(alldata)
    if i == 3
        name_1 = alldata(i,1);
        list(k2,k1) = i;
        k2 = k2 + 1;
    else
        if strcmp(alldata(i,1),name_1) == 1
            list(k2,k1) = i;
            k2 = k2 + 1;
        else
            k1 = k1 + 1; k2 = 1;
            list(k2,k1) = i;
            name_1 = alldata(i,1);
            k2 = k2 + 1;
        end
    end
end

[a1 a2] = size(list);
in1 = 0; in2 = 0;
for i = 1:a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if i == 1
            in1 = in1 + 1;
            name_list(in1) = (alldata(list(1,i),1));
        else
            for j = 1:in1
                if strcmp(char(alldata(list(1,i),1)),char(name_list(j))) == 0
                    in2 = in2 + 1;
                end
            end
            if in1 == in2
                in1 = in1 + 1;
                name_list(in1) = (alldata(list(1,i),1));
            end
        end
    end
end

% Drift
d = 0;
for i = 1 : a2
    n = 0; r = 0;
    for j = 2:a1
        if list(j,i) > 0 && iscellstr(alldata(list(j,i))) == 1
            if strcmp(alldata(list(j,i),7),'BENDMARK') == 1 || strcmp(alldata(list(j,i),7),'MIAC') == 1
                n = n + 1;
            else
                if strcmp(char(alldata(list(j,i),6)),'SBEN') == 1
                    if cell2mat(alldata(list(j,i),10)) == 0 || cell2mat(alldata(list(j,i),11)) == 0
                        arc_len_1 = cell2mat(alldata(list(j,i),8)) * cell2mat(alldata(list(j,i),9)) / sin(cell2mat(alldata(list(j,i),9)));
                    else
                        arc_len_1 = 0.5 * cell2mat(alldata(list(j,i),8)) * cell2mat(alldata(list(j,i),9)) / sin(0.5*cell2mat(alldata(list(j,i),9)));
                    end
                    if strcmp(char(alldata(list(j-1-n,i),6)),'SBEN') == 1
                        if cell2mat(alldata(list(j-1-n,i),10)) == 0 || cell2mat(alldata(list(j-1-n,i),11)) == 0
                            arc_len_2 = cell2mat(alldata(list(j-1-n,i),8)) * cell2mat(alldata(list(j-1-n,i),9)) / sin(cell2mat(alldata(list(j-1-n,i),9)));
                        else
                            arc_len_2 = 0.5 * cell2mat(alldata(list(j-1-n,i),8)) * cell2mat(alldata(list(j-1-n,i),9)) / sin(0.5*cell2mat(alldata(list(j-1-n,i),9)));
                        end
                        diff_d = cell2mat(alldata(list(j,i),13)) - arc_len_1/2 - cell2mat(alldata(list(j-1-n,i),13)) - arc_len_2/2;
                    else
                        diff_d = cell2mat(alldata(list(j,i),13)) - arc_len_1/2 - cell2mat(alldata(list(j-1-n,i),13)) - cell2mat(alldata(list(j-1-n,i),8))/2;
                    end
                else
                    if strcmp(char(alldata(list(j-1-n,i),6)),'SBEN') == 1
                        if cell2mat(alldata(list(j-1-n,i),10)) == 0 || cell2mat(alldata(list(j-1-n,i),11)) == 0
                            arc_len_2 = cell2mat(alldata(list(j-1-n,i),8)) * cell2mat(alldata(list(j-1-n,i),9)) / sin(cell2mat(alldata(list(j-1-n,i),9)));
                        else
                            arc_len_2 = 0.5 * cell2mat(alldata(list(j-1-n,i),8)) * cell2mat(alldata(list(j-1-n,i),9)) / sin(0.5*cell2mat(alldata(list(j-1-n,i),9)));
                        end
                        diff_d = cell2mat(alldata(list(j,i),13)) - cell2mat(alldata(list(j,i),8))/2 - cell2mat(alldata(list(j-1-n,i),13)) - arc_len_2/2;
                    else
                        diff_d = cell2mat(alldata(list(j,i),13)) - cell2mat(alldata(list(j,i),8))/2 - cell2mat(alldata(list(j-1-n,i),13)) - cell2mat(alldata(list(j-1-n,i),8))/2;
                    end
                end
                if cell2mat(alldata(list(j-1-n,i),13)) < 0
                    diff_d = cell2mat(alldata(list(j,i),13));
                end
                if diff_d > 1e-10
                    if d == 0
                        d = d + 1;
                        tem = sprintf('%2.9f',diff_d);
                        [t_1,t_2] = strtok(tem,'.');
                        [t_3,t_4] = strtok(t_2,'.');
                        drift_name(d) = cellstr(sprintf('D%s%s',t_1,t_3));
                        drift_length(d) = diff_d;
                    else
                        if length(find(abs(diff_d - drift_length(1:d))<1e-10)) == 0
                            d = d + 1;
                            tem = sprintf('%2.9f',diff_d);
                            [t_1,t_2] = strtok(tem,'.');
                            [t_3,t_4] = strtok(t_2,'.');
                            drift_name(d) = cellstr(sprintf('D%s%s',t_1,t_3));
                            drift_length(d) = diff_d;
                        end
                    end
                end
                n = 0;
            end
         end
    end
end

% CL - TL drift
diff_d = cell2mat(alldata(list(1,8),13)) - cell2mat(alldata(list(1,8),8))/2 - cell2mat(alldata(list(216,7),13)) - cell2mat(alldata(list(216,7),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_TL_0 = drift_name(t);
    drift_length_TL_0 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_TL_0 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_TL_0 = diff_d;
end

% TL - TLD - TL drift
diff_d = cell2mat(alldata(list(1,10),13)) - cell2mat(alldata(list(1,10),8))/2 - cell2mat(alldata(list(1,9),13)) - cell2mat(alldata(list(1,9),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_TLD_0 = drift_name(t);
    drift_length_TLD_0 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_TLD_0 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_TLD_0 = diff_d;
end

% TL - T1 - TL drift
diff_d = cell2mat(alldata(list(1,12),13)) - cell2mat(alldata(list(1,12),8))/2 - cell2mat(alldata(list(1,11),13)) - cell2mat(alldata(list(1,11),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_T1TL_1 = drift_name(t);
    drift_length_T1TL_1 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_T1TL_1 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_T1TL_1 = diff_d;
end

% TL - T20 - TL drift
diff_d = cell2mat(alldata(list(1,14),13)) - cell2mat(alldata(list(1,14),8))/2 - cell2mat(alldata(list(2,13),13)) - cell2mat(alldata(list(2,13),8))/2;
tem = sprintf('%2.9f',diff_d);
[t_1,t_2] = strtok(tem,'.');
[t_3,t_4] = strtok(t_2,'.');
drift_name_TL_1 = cellstr(sprintf('D%s%s',t_1,t_3));
drift_length_TL_1 = diff_d;

diff_d = cell2mat(alldata(list(1,16),13)) - cell2mat(alldata(list(1,16),8))/2 - cell2mat(alldata(list(6,14),13)) - cell2mat(alldata(list(6,14),8))/2;
tem = sprintf('%2.9f',diff_d);
[t_1,t_2] = strtok(tem,'.');
[t_3,t_4] = strtok(t_2,'.');
drift_name_TL_2 = cellstr(sprintf('D%s%s',t_1,t_3));
drift_length_TL_2 = diff_d;

% TL - T20 - TL
diff_d = cell2mat(alldata(list(1,15),13)) - cell2mat(alldata(list(1,15),8))/2 - cell2mat(alldata(list(6,14),13)) - cell2mat(alldata(list(6,14),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_TLT20_1 = drift_name(t);
    drift_length_TLT20_1 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_TLT20_1 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_TLT20_1 = diff_d;
end

diff_d = cell2mat(alldata(list(1,16),13)) - cell2mat(alldata(list(1,16),8))/2 - cell2mat(alldata(list(1,15),13)) - cell2mat(alldata(list(1,15),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_T20TL_1 = drift_name(t);
    drift_length_T20TL_1 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_T20TL_1 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_T20TL_1 = diff_d;
end

% TL - T1 drift
diff_d = cell2mat(alldata(list(1,16),13)) - cell2mat(alldata(list(1,16),8))/2 - cell2mat(alldata(list(1,15),13)) - cell2mat(alldata(list(1,15),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_TL_3 = drift_name(t);
    drift_length_TL_3 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_TL_3 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_TL_3 = diff_d;
end

diff_d = cell2mat(alldata(list(7,24),13)) - cell2mat(alldata(list(7,24),8))/2 - cell2mat(alldata(list(1,12),13)) - cell2mat(alldata(list(1,12),8))/2;
tem = sprintf('%2.9f',diff_d);
[t_1,t_2] = strtok(tem,'.');
[t_3,t_4] = strtok(t_2,'.');
drift_name_TL_4 = cellstr(sprintf('D%s%s',t_1,t_3));
drift_length_TL_4 = diff_d;

% T1 - T2 - T1 drift
diff_d = cell2mat(alldata(list(1,25),13)) - cell2mat(alldata(list(1,25),8))/2 - cell2mat(alldata(list(90,24),13)) - cell2mat(alldata(list(90,24),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_T1_1 = drift_name(t);
    drift_length_T1_1 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_T1_1 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_T1_1 = diff_d;
end

diff_d = cell2mat(alldata(list(1,26),13)) - cell2mat(alldata(list(1,26),8))/2 - cell2mat(alldata(list(1,25),13)) - cell2mat(alldata(list(1,25),8))/2;
tem = sprintf('%2.9f',diff_d);
[t_1,t_2] = strtok(tem,'.');
[t_3,t_4] = strtok(t_2,'.');
drift_name_T1_2 = cellstr(sprintf('D%s%s',t_1,t_3));
drift_length_T1_2 = diff_d;

% T2 - T20 drift
diff_d = cell2mat(alldata(list(1,19),13)) - cell2mat(alldata(list(1,19),8))/2 - cell2mat(alldata(list(3,18),13)) - cell2mat(alldata(list(3,18),8))/2;
tem = sprintf('%2.9f',diff_d);
[t_1,t_2] = strtok(tem,'.');
[t_3,t_4] = strtok(t_2,'.');
drift_name_T2 = cellstr(sprintf('D%s%s',t_1,t_3));
drift_length_T2 = diff_d;

% T5D (BPMD.3172.T4D is removed)
diff_d = cell2mat(alldata(list(1,34),13)) - cell2mat(alldata(list(1,34),8))/2 - cell2mat(alldata(list(43,32),13)) - cell2mat(alldata(list(43,32),8))/2;
tem = sprintf('%2.9f',diff_d);
[t_1,t_2] = strtok(tem,'.');
[t_3,t_4] = strtok(t_2,'.');
drift_name_T5D = cellstr(sprintf('D%s%s',t_1,t_3));
drift_length_T5D = diff_d;

% T2 - SA1 drift
diff_d = cell2mat(alldata(list(1,20),13)) - cell2mat(alldata(list(1,20),8))/2 - cell2mat(alldata(list(50,19),13)) - cell2mat(alldata(list(50,19),8))/2;
t = find(abs(diff_d-drift_length(1:end))<1e-10);
if t > 0
    drift_name_T2SA1_1 = drift_name(t);
    drift_length_T2SA1_1 = drift_length(t);
else
    tem = sprintf('%2.9f',diff_d);
    [t_1,t_2] = strtok(tem,'.');
    [t_3,t_4] = strtok(t_2,'.');
    drift_name_T2SA1_1 = cellstr(sprintf('D%s%s',t_1,t_3));
    drift_length_T2SA1_1 = diff_d;
end

f_lat = fopen('XFEL_elegant.lte','w+');

fprintf(f_lat,'! \n! XFEL lattice\n');
fprintf(f_lat,'! component_list_8.3.xls -> elegant_lattice\n!\n\n');

fprintf(f_lat,'Q : CHARGE,TOTAL=1e-9 \n\n');

fprintf(f_lat,'! \n! DRIFT \n!\n');
for i = 1:length(drift_length)
    fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name(i)),drift_length(i));
end
fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_TLD_0),drift_length_TLD_0);
%fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_T1TL_1),drift_length_T1TL_1);
%fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_TLT20_1),drift_length_TLT20_1);
%fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_T20TL_1),drift_length_T20TL_1);
fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_TL_1),drift_length_TL_1);
fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_TL_2),drift_length_TL_2);
fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_TL_4),drift_length_TL_4);
fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_T1_2),drift_length_T1_2);
fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_T2),drift_length_T2);
fprintf(f_lat,'%s :   DRIFT, L = %2.9f \n',char(drift_name_T5D),drift_length_T5D);

k_mark = find(strcmp(alldata(:,6),'MARK') == 1);
fprintf(f_lat,'! \n! MARKER \n!\n');
for i = 1:length(k_mark)
    fprintf(f_lat,'%s :   MARK \n',char(alldata(k_mark(i),3)));
end

k_moni = find(strcmp(alldata(:,6),'MONI') == 1);
fprintf(f_lat,'! \n! MONITOR \n!\n');
for i = 1:length(k_moni)
    fprintf(f_lat,'%s :   MONI \n',char(alldata(k_moni(i),3)));
end

k_kick = find(strcmp(alldata(:,6),'KICK') == 1);
fprintf(f_lat,'! \n! KICKER \n!\n');
for i = 1:length(k_kick)
    fprintf(f_lat,'%s :   KICK, L = %2.7f \n',char(alldata(k_kick(i),3)),cell2mat(alldata(k_kick(i),8)));
end

k_hkick = find(strcmp(alldata(:,6),'HKIC') == 1);
fprintf(f_lat,'! \n! HKICKER \n!\n');
for i = 1:length(k_hkick)
    fprintf(f_lat,'%s :   HKICK, L = %2.7f \n',char(alldata(k_hkick(i),3)),cell2mat(alldata(k_hkick(i),8)));
end

k_vkick = find(strcmp(alldata(:,6),'VKIC') == 1);
fprintf(f_lat,'! \n! VKICKER \n!\n');
for i = 1:length(k_vkick)
    fprintf(f_lat,'%s :   VKICK, L = %2.7f \n',char(alldata(k_vkick(i),3)),cell2mat(alldata(k_vkick(i),8)));
end

k_lacv = find(strcmp(alldata(:,6),'LCAV') == 1);
fprintf(f_lat,'! \n! RF CAVITY \n!\n');
for i = 1:length(k_lacv)
    fprintf(f_lat,'%s :   RFCA, L = %2.7f, PHASE = %2.3f, VOLT = %2.3f, FREQ = %1.3e, & \n    CHANGE_P0 = 1, END1_FOCUS = 1, END2_FOCUS = 1, BODY_FOCUS_MODEL = "SRS" \n',...
        char(alldata(k_lacv(i),3)),cell2mat(alldata(k_lacv(i),8)),90 - cell2mat(alldata(k_lacv(i),17)) + cell2mat(alldata(k_lacv(i),10))*360, cell2mat(alldata(k_lacv(i),9))*1e6, cell2mat(alldata(k_lacv(i),11))*1e6 );
end

k_sole = find(strcmp(alldata(:,6),'SOLE') == 1);
fprintf(f_lat,'! \n! SOLENOID \n!\n');
for i = 1:length(k_sole)
    fprintf(f_lat,'%s :   SOLE, L = %2.7f \n',char(alldata(k_sole(i),3)),cell2mat(alldata(k_sole(i),8)));
end

k_rben = find(strcmp(alldata(:,6),'RBEN') == 1);
fprintf(f_lat,'! \n! RBEND \n!\n');
for i = 1:length(k_rben)
    fprintf(f_lat,'%s :   RBEN, L = %2.7f, ANGLE = %2.9f, E1 = %2.9f, E2 = %2.9f, TILT = %2.9f \n',...
        char(alldata(k_rben(i),3)),cell2mat(alldata(k_rben(i),8)),cell2mat(alldata(k_rben(i),9)),cell2mat(alldata(k_rben(i),10)),cell2mat(alldata(k_rben(i),11)),cell2mat(alldata(k_rben(i),12)));
end

k_sben = find(strcmp(alldata(:,6),'SBEN') == 1);
fprintf(f_lat,'! \n! SBEND \n!\n');
for i = 1:length(k_sben)
    if TD == 1
        if strcmp(char(alldata(k_sben(i),4)),'BZ.1.T1') == 1 || strcmp(char(alldata(k_sben(i),4)),'BZ.2.T1') == 1
                fprintf(f_lat,'%s :   SBEN, L = %2.7f, ANGLE = %2.9f, E1 = %2.9f, E2 = %2.9f, TILT = %2.9f \n',...
            char(alldata(k_sben(i),3)),cell2mat(alldata(k_sben(i),8)),cell2mat(alldata(k_sben(i),9)),cell2mat(alldata(k_sben(i),9))/2,cell2mat(alldata(k_sben(i),9))/2,cell2mat(alldata(k_sben(i),12)));
        elseif strcmp(char(alldata(k_sben(i),4)),'BZ.1.TLD') == 1 || strcmp(char(alldata(k_sben(i),4)),'BZ.2.TLD') == 1 && strcmp(char(alldata(k_sben(i),4)),'BZ.1.TLD') == 1 || strcmp(char(alldata(k_sben(i),4)),'BZ.2.TLD') == 1
                fprintf(f_lat,'%s :   SBEN, L = %2.7f, ANGLE = %2.9f, E1 = %2.9f, E2 = %2.9f, TILT = %2.9f \n',...
            char(alldata(k_sben(i),3)),cell2mat(alldata(k_sben(i),8)),0,0,0,0);
        else
            if cell2mat(alldata(k_sben(i),10)) == 0 || cell2mat(alldata(k_sben(i),11)) == 0
                arc_len = cell2mat(alldata(k_sben(i),8)) * cell2mat(alldata(k_sben(i),9)) / sin(cell2mat(alldata(k_sben(i),9)));
            else
                arc_len = 0.5 * cell2mat(alldata(k_sben(i),8)) * cell2mat(alldata(k_sben(i),9)) / sin(0.5*cell2mat(alldata(k_sben(i),9)));
            end 
            fprintf(f_lat,'%s :   SBEN, L = %2.7f, ANGLE = %2.9f, E1 = %2.9f, E2 = %2.9f, TILT = %2.9f \n',...
                char(alldata(k_sben(i),3)),arc_len,cell2mat(alldata(k_sben(i),9)),cell2mat(alldata(k_sben(i),10)),cell2mat(alldata(k_sben(i),11)),cell2mat(alldata(k_sben(i),12)));
        end
    elseif TD == 2
        if strcmp(char(alldata(k_sben(i),4)),'BZ.1.T1') == 1 || strcmp(char(alldata(k_sben(i),4)),'BZ.2.T1') == 1 || strcmp(char(alldata(k_sben(i),4)),'BZ.1.TLD') == 1 || strcmp(char(alldata(k_sben(i),4)),'BZ.2.TLD') == 1
                fprintf(f_lat,'%s :   SBEN, L = %2.7f, ANGLE = %2.9f, E1 = %2.9f, E2 = %2.9f, TILT = %2.9f \n',...
            char(alldata(k_sben(i),3)),cell2mat(alldata(k_sben(i),8)),0,0,0,0);
        else
            if cell2mat(alldata(k_sben(i),10)) == 0 || cell2mat(alldata(k_sben(i),11)) == 0
                arc_len = cell2mat(alldata(k_sben(i),8)) * cell2mat(alldata(k_sben(i),9)) / sin(cell2mat(alldata(k_sben(i),9)));
            else
                arc_len = 0.5 * cell2mat(alldata(k_sben(i),8)) * cell2mat(alldata(k_sben(i),9)) / sin(0.5*cell2mat(alldata(k_sben(i),9)));
            end 
            fprintf(f_lat,'%s :   SBEN, L = %2.7f, ANGLE = %2.9f, E1 = %2.9f, E2 = %2.9f, TILT = %2.9f \n',...
                char(alldata(k_sben(i),3)),arc_len,cell2mat(alldata(k_sben(i),9)),cell2mat(alldata(k_sben(i),10)),cell2mat(alldata(k_sben(i),11)),cell2mat(alldata(k_sben(i),12)));
        end
    end
end

k_quad = find(strcmp(alldata(:,6),'QUAD') == 1);
fprintf(f_lat,'! \n! QUADRUPOLE \n!\n');
for i = 1:length(k_quad)
    fprintf(f_lat,'%s :   QUAD, L = %2.7f, K1 = %2.9f, TILT = %2.9f \n',char(alldata(k_quad(i),3)),cell2mat(alldata(k_quad(i),8)),cell2mat(alldata(k_quad(i),9))/cell2mat(alldata(k_quad(i),8)),cell2mat(alldata(k_quad(i),12)));
end

k_sext = find(strcmp(alldata(:,6),'SEXT') == 1);
fprintf(f_lat,'! \n! SEXTUPOLE \n!\n');
for i = 1:length(k_sext)
    fprintf(f_lat,'%s :   SEXT, L = %2.7f, K2 = %2.9f, TILT = %2.9f \n',char(alldata(k_sext(i),3)),cell2mat(alldata(k_sext(i),8)),cell2mat(alldata(k_sext(i),9))/cell2mat(alldata(k_sext(i),8)),cell2mat(alldata(k_sext(i),12)));
end

k_octu = find(strcmp(alldata(:,6),'OCTU') == 1);
fprintf(f_lat,'! \n! OCTUPOLE \n!\n');
for i = 1:length(k_octu)
    fprintf(f_lat,'%s :   MULT, L = %2.7f, ORDER = 3, KNL = %2.9f, TILT = %2.9f \n',char(alldata(k_octu(i),3)),cell2mat(alldata(k_octu(i),8)),cell2mat(alldata(k_octu(i),9))/cell2mat(alldata(k_octu(i),8)),cell2mat(alldata(k_octu(i),12)));
end

k_undu = find(strcmp(alldata(:,6),'UNDULATO') == 1);
fprintf(f_lat,'! \n! UNDULATOR \n!\n');
for i = 1:length(k_undu)
    if i == 1
        gamma_0 = 0.13 / 0.511e-3; beta_0 = 1 / sqrt(1-1/gamma_0^2); L_0 = 0.074*10; Kund_0 = 0.934* L_0*10 * 0.28;
        Omega_0 = 2*3.14159265*Kund_0/0.074/gamma_0/beta_0/sqrt(2); 
        R33_0 = cos(Omega_0*L_0); R34_0 = sin(Omega_0*L_0)/Omega_0;
        R43_0 = -sin(Omega_0*L_0)*Omega_0; R44_0 = R33_0;
        fprintf(f_lat,'%s :   EMATRIX, L = %2.7f, R11 = 1.0, R12 = %2.7f, R22 = 1.0, & \n    R33 = %2.7f, R34 = %2.7f, R43 = %2.7f, R44 = %2.7f, R55 = 1, R66 = 1 \n',...
            char(alldata(k_undu(i),3)),cell2mat(alldata(k_undu(i),8)),L_0,R33_0,R34_0,R43_0,R44_0);
    
    elseif i > 1 && i < 37 % SA1
        gamma = 14.0 / 0.511e-3; beta = 1 / sqrt(1-1/gamma^2);
        Omega_1 = 2*3.14159265*4.27351/0.04/gamma/beta/sqrt(2); L_1 = 0.04*125;
        R33_1 = cos(Omega_1*L_1); R34_1 = sin(Omega_1*L_1)/Omega_1;
        R43_1 = -sin(Omega_1*L_1)*Omega_1; R44_1 = R33_1;
        fprintf(f_lat,'%s :   EMATRIX, L = %2.7f, R11 = 1.0, R12 = %2.7f, R22 = 1.0, & \n    R33 = %2.7f, R34 = %2.7f, R43 = %2.7f, R44 = %2.7f, R55 = 1, R66 = 1 \n',...
            char(alldata(k_undu(i),3)),cell2mat(alldata(k_undu(i),8)),L_1,R33_1,R34_1,R43_1,R44_1);
    
    elseif i > 36 && i < 59 % SA3
        Omega_3 = 2*3.14159265*4.27351/0.068/gamma/beta/sqrt(2); L_3 = 0.068*73;
        R33_3 = cos(Omega_3*L_3); R34_3 = sin(Omega_3*L_3)/Omega_3;
        R43_3 = -sin(Omega_3*L_3)*Omega_3; R44_3 = R33_3;
        fprintf(f_lat,'%s :   EMATRIX, L = %2.7f, R11 = 1.0, R12 = %2.7f, R22 = 1.0, & \n    R33 = %2.7f, R34 = %2.7f, R43 = %2.7f, R44 = %2.7f, R55 = 1, R66 = 1  \n',...
            char(alldata(k_undu(i),3)),cell2mat(alldata(k_undu(i),8)),L_3,R33_3,R34_3,R43_3,R44_3);
    
    elseif i > 58 % SA2
        Omega_2 = 2*3.14159265*4.27351/0.04/gamma/beta/sqrt(2); L_2 = 0.04*125;
        R33_2 = cos(Omega_2*L_2); R34_2 = sin(Omega_2*L_2)/Omega_2;
        R43_2 = -sin(Omega_2*L_2)*Omega_2; R44_2 = R33_2;
        fprintf(f_lat,'%s :   EMATRIX, L = %2.7f, R11 = 1.0, R12 = %2.7f, R22 = 1.0, & \n    R33 = %2.7f, R34 = %2.7f, R43 = %2.7f, R44 = %2.7f, R55 = 1, R66 = 1  \n',...
            char(alldata(k_undu(i),3)),cell2mat(alldata(k_undu(i),8)),L_2,R33_2,R34_2,R43_2,R44_2);
    end
end

k_ecol = find(strcmp(alldata(:,6),'ECOL') == 1);
fprintf(f_lat,'! \n! COLLIMATOR \n!\n');
for i = 1:length(k_ecol)
    fprintf(f_lat,'%s :   ECOL, L= %2.7f, X_MAX = %2.7f, Y_MAX = %2.7f \n',char(alldata(k_ecol(i),3)),cell2mat(alldata(k_ecol(i),8)),cell2mat(alldata(k_ecol(i),48)),cell2mat(alldata(k_ecol(i),49)));
end

k_cryo = find(strcmp(alldata(:,6),'CRYO') == 1);
fprintf(f_lat,'! \n! CRYO \n!\n');
for i = 1:length(k_cryo)
    fprintf(f_lat,'%s :   DRIFT, L = %2.7f \n',char(alldata(k_cryo(i),3)),cell2mat(alldata(k_cryo(i),8)));
end

k_instr = find(strcmp(alldata(:,6),'INSTR') == 1);
fprintf(f_lat,'! \n! INSTR \n!\n');
for i = 1:length(k_instr)
    fprintf(f_lat,'%s :   MARK \n',char(alldata(k_instr(i),3)));
end

k_instr = find(strcmp(alldata(:,7),'BENDMARK') == 1);
fprintf(f_lat,'! \n! BENDMARK \n!\n');
for i = 1:length(k_instr)
    fprintf(f_lat,'%s :   MARK \n',char(alldata(k_instr(i),3)));
end

k_phase = find(strcmp(alldata(:,6),'PHASESHI') == 1);
fprintf(f_lat,'! \n! PHASE SHIFTER \n!\n');
for i = 1:length(k_phase)
    fprintf(f_lat,'%s :   DRIFT, L = %2.7f \n',char(alldata(k_phase(i),3)),cell2mat(alldata(k_phase(i),8)));
end

k_place = find(strcmp(alldata(:,6),'PLACEH') == 1);
fprintf(f_lat,'! \n! PLACEH \n!\n');
for i = 1:length(k_place)
    fprintf(f_lat,'%s :   DRIFT, L = %2.7f \n',char(alldata(k_place(i),3)),cell2mat(alldata(k_place(i),8)));
end

k_vac = find(strcmp(alldata(:,6),'VAC') == 1);
fprintf(f_lat,'! \n! VACUUM \n!\n');
for i = 1:length(k_vac)
    fprintf(f_lat,'%s :   DRIFT, L = %2.7f \n',char(alldata(k_vac(i),3)),cell2mat(alldata(k_vac(i),8)));
end


% I1
in1 = 0; m1 = 0; m2 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'I1') == 1 || strcmp(char(alldata(list(1,i),1)),'I1D') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    n = 0;
    if j == 1 % I1
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1 || strcmp(char(alldata(list(k,I1(j)),7)),'MIAC') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1,I1(j)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(j)),13));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    if strcmp(char(alldata(list(k,I1(j)),4)),'START.I1D.I1') == 1
                        m1 = k;
                    end
                    if strcmp(char(alldata(list(k,I1(j)),4)),'START.DARM.I1') == 1
                        m2 = k;
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end 
    elseif j == 2 % I1 Dump
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : m1
            if list(k,I1(1)) > 0 && iscellstr(alldata(list(k,I1(1)))) == 1
                if strcmp(char(alldata(list(k,I1(1)),7)),'BENDMARK') == 1 || strcmp(char(alldata(list(k,I1(1)),7)),'MIAC') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(1)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(1)),10)) == 0 || cell2mat(alldata(list(k,I1(1)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(cell2mat(alldata(list(k,I1(1)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(1)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(1)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(1)),3)));
                    if k < a1
                        if list(k+1,I1(1)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
        end  
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(j)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end  
    elseif j == 3 % I1 Dispersive Arm
        fprintf(f_lat,'\n! Injector Dispersive Arm');
        fprintf(f_lat,'\n%s : LINE = ( ','I1DARM');
        for k = 1 : m2
            if list(k,I1(1)) > 0 && iscellstr(alldata(list(k,I1(1)))) == 1
                if strcmp(char(alldata(list(k,I1(1)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(1)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(1)),10)) == 0 || cell2mat(alldata(list(k,I1(1)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(cell2mat(alldata(list(k,I1(1)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(1)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(1)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(1)),3)));
                    if k < a1
                        if list(k+1,I1(1)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
        end  
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 2
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(j)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end  
    end
end

% L1
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'L1') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 % L1
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'MIAC') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end
  
% B1
in1 = 0; m1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'B1') == 1 || strcmp(char(alldata(list(1,i),1)),'B1D') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    n = 0;
    if j == 1 % B1
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(j)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    if strcmp(char(alldata(list(k,I1(j)),4)),'STARTB1D') == 1
                        m1 = k;
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end 
    elseif j == 2 % B1 Dump
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : m1
            if list(k,I1(1)) > 0 && iscellstr(alldata(list(k,I1(1)))) == 1
                if strcmp(char(alldata(list(k,I1(1)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(1)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(1)),10)) == 0 || cell2mat(alldata(list(k,I1(1)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(cell2mat(alldata(list(k,I1(1)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(1)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(1)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(1)),3)));
                    if k < a1
                        if list(k+1,I1(1)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
        end  
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(j)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end        
    end
end

% L2
in1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'L2') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 % L2
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'MIAC') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% B2
in1 = 0; m1 = 0; 
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'B2') == 1 || strcmp(char(alldata(list(1,i),1)),'B2D') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    n = 0;
    if j == 1 % B2
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(j)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    if strcmp(char(alldata(list(k,I1(j)),4)),'STARTB2D') == 1
                         m1 = k;
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end 
    elseif j == 2 % B2 Dump
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : m1
            if list(k,I1(1)) > 0 && iscellstr(alldata(list(k,I1(1)))) == 1
                if strcmp(char(alldata(list(k,I1(1)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(1)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(1)),10)) == 0 || cell2mat(alldata(list(k,I1(1)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(cell2mat(alldata(list(k,I1(1)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(1)),8)) * cell2mat(alldata(list(k,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(1)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(1)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(1)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(1)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(1)),8)) * cell2mat(alldata(list(k-1-n,I1(1)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(1)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k,I1(1)),8))/2 - cell2mat(alldata(list(k-1-n,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(1)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(1)),13)) - cell2mat(alldata(list(k-1-n,I1(1)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(1)),3)));
                    if k < a1
                        if list(k+1,I1(1)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
        end  
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if cell2mat(alldata(list(k-1-n,I1(j)),13)) < 0
                            diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8));
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end        
    end
end

% L3
in1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'L3') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 % L3
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'MIAC') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% CL
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'CL') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 % CL
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1 || strcmp(char(alldata(list(k,I1(j)),4)),'START.ARC.CL') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% TL-TLD
in1 = 0; n = 0;
for i1 = 1 : a2
    if iscellstr(alldata(list(1,i1),1)) == 1
        if strcmp(char(alldata(list(1,i1),1)),'TL') == 1
            in1 = in1 + 1;
            I1(in1) = i1;
        end
    end
end
in2 = 0;
for i2 = 1 : a2
    if iscellstr(alldata(list(1,i2),1)) == 1
        if strcmp(char(alldata(list(1,i2),1)),'TLD') == 1
            in2 = in2 + 1;
            I2(in2) = i2;
        end
    end
end
m = 0; n1 = 0; n2 = 0;
for j = 1:in1
    for k = 1 : a1
        if j == 1 && k == 1
            fprintf(f_lat,'\n%s%s : LINE = ( %s,',char(alldata(list(1,I1(j)),1)),char(alldata(list(1,I2(j)),1)),char(drift_name_TL_0));
        end
        if j == 2 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_TLD_0));
        end
        if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1 && m == 0
            n1 = n1 + 1;
            if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
            else
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
                if strcmp(char(alldata(list(k,I1(j)),4)),'STARTTLD') == 1
                    fprintf(f_lat,', &\n    ');
                    m = 1;
                    break;
                end
                n = 0;
            end
        end
        if m == 1
            break;
        end
    end
    if n1 == 1
        fprintf(f_lat,', &\n    ');
    end
    if m == 1
        break;
    end
end
n = 0;
for j = 1:in2
    for k = 1 : a1
        if list(k,I2(j)) > 0 && iscellstr(alldata(list(k,I2(j)))) == 1
            n2 = n2 + 1;
            if strcmp(char(alldata(list(k,I2(j)),7)),'BENDMARK') == 1
                    n = n + 1;
            else
                if k > 2
                    if strcmp(char(alldata(list(k,I2(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I2(j)),10)) == 0 || cell2mat(alldata(list(k,I2(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I2(j)),8)) * cell2mat(alldata(list(k,I2(j)),9)) / sin(cell2mat(alldata(list(k,I2(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I2(j)),8)) * cell2mat(alldata(list(k,I2(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I2(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I2(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I2(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I2(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I2(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I2(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I2(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I2(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - cell2mat(alldata(list(k-1-n,I2(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I2(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I2(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I2(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I2(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I2(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I2(j)),13)) - cell2mat(alldata(list(k,I2(j)),8))/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I2(j)),13)) - cell2mat(alldata(list(k,I2(j)),8))/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - cell2mat(alldata(list(k-1-n,I2(j)),8))/2;
                            end
                    end
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I2(j)),3)));
                if k < a1
                    if list(k+1,I2(j)) ~= 0
                         fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
                n = 0;
            end
        end
    end
    if n2 == 1
        fprintf(f_lat,', '); 
    end
    if j == in2
        fprintf(f_lat,' ) \n\n'); 
    end
end

% TL-T1
in1 = 0; n = 0;
for i1 = 1 : a2
    if iscellstr(alldata(list(1,i1),1)) == 1
        if strcmp(char(alldata(list(1,i1),1)),'TL') == 1
            in1 = in1 + 1;
            I1(in1) = i1;
        end
    end
end
in2 = 0;
for i2 = 1 : a2
    if iscellstr(alldata(list(1,i2),1)) == 1
        if strcmp(char(alldata(list(1,i2),1)),'T1') == 1
            in2 = in2 + 1;
            I2(in2) = i2;
        end
    end
end
in3 = 0;
for i3 = 1 : a2
    if iscellstr(alldata(list(1,i3),1)) == 1
        if strcmp(char(alldata(list(1,i3),1)),'T2') == 1
            in3 = in3 + 1;
            I3(in3) = i3;
        end
    end
end
in4 = 0;
for i4 = 1 : a2
    if iscellstr(alldata(list(1,i4),1)) == 1
        if strcmp(char(alldata(list(1,i4),1)),'T20') == 1
            in4 = in4 + 1;
            I4(in4) = i4;
        end
    end
end
m = 0; n1 = 0; n2 = 0;
for j = 1:in1
    for k = 1 : a1
        if j == 1 && k == 1
            fprintf(f_lat,'\n%s%s : LINE = ( %s, ',char(alldata(list(1,I1(j)),1)),char(alldata(list(1,I2(j)),1)),char(drift_name_TL_0));
        end
        if j == 2 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_TLD_0));
        end
        if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1 && m == 0
            n1 = n1 + 1;
            if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
            else
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
                if strcmp(char(alldata(list(k,I1(j)),4)),'STARTT1') == 1
                    m = 1;
                    break;
                end
                n = 0;
            end
        end
        if m == 1
            break;
        end
    end
    fprintf(f_lat,', &\n    ');
    if m == 1
        break;
    end
end
n = 0;
for j = 1:in2
    for k = 1 : a1
        if list(k,I2(j)) > 0 && iscellstr(alldata(list(k,I2(j)))) == 1
            n2 = n2 + 1;
            if strcmp(char(alldata(list(k,I2(j)),7)),'BENDMARK') == 1
                n = n + 1;
            else
                if k == 2 && j == in2
                    diff_d = cell2mat(alldata(list(k,I2(j)),13)) - cell2mat(alldata(list(k,I2(j)),8))/2 - cell2mat(alldata(list(k-1,I2(j)),13)) - cell2mat(alldata(list(k-1,I2(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                if k > 2
                    if strcmp(char(alldata(list(k,I2(j)),6)),'SBEN') == 1
                        if cell2mat(alldata(list(k,I2(j)),10)) == 0 || cell2mat(alldata(list(k,I2(j)),11)) == 0
                            arc_len_1 = cell2mat(alldata(list(k,I2(j)),8)) * cell2mat(alldata(list(k,I2(j)),9)) / sin(cell2mat(alldata(list(k,I2(j)),9)));
                        else
                            arc_len_1 = 0.5 * cell2mat(alldata(list(k,I2(j)),8)) * cell2mat(alldata(list(k,I2(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I2(j)),9)));
                        end
                        if strcmp(char(alldata(list(k-1-n,I2(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k-1-n,I2(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I2(j)),11)) == 0
                                arc_len_2 = cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I2(j)),9)));
                            else
                                arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I2(j)),9)));
                            end
                            diff_d = cell2mat(alldata(list(k,I2(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - arc_len_2/2;
                        else
                            diff_d = cell2mat(alldata(list(k,I2(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - cell2mat(alldata(list(k-1-n,I2(j)),8))/2;
                        end
                    else
                        if strcmp(char(alldata(list(k-1-n,I2(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k-1-n,I2(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I2(j)),11)) == 0
                                arc_len_2 = cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I2(j)),9)));
                            else
                                arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I2(j)),8)) * cell2mat(alldata(list(k-1-n,I2(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I2(j)),9)));
                            end
                            diff_d = cell2mat(alldata(list(k,I2(j)),13)) - cell2mat(alldata(list(k,I2(j)),8))/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - arc_len_2/2;
                        else
                            diff_d = cell2mat(alldata(list(k,I2(j)),13)) - cell2mat(alldata(list(k,I2(j)),8))/2 - cell2mat(alldata(list(k-1-n,I2(j)),13)) - cell2mat(alldata(list(k-1-n,I2(j)),8))/2;
                        end
                    end
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1 && strcmp(char(alldata(list(k,I2(j)),3)),'BZ.2030.T1') ~= 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                %if strcmp(char(alldata(list(k,I2(j)),3)),'BZ.2031.T1') ~= 1
                    fprintf(f_lat,'%s',char(alldata(list(k,I2(j)),3)));
                %end
                if k < a1
                    if list(k+1,I2(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,4) == 0
                    fprintf(f_lat,'&\n    ');
                end
                n = 0;
            end
            if strcmp(char(alldata(list(k,I2(j)),3)),'BZ.2025.T1') == 1
                fprintf(f_lat,'%s, %s, %s, &\n    ',char(drift_name_TL_3),'QK.2027.TL',char(drift_name_TL_4));
            end
        end
    end
    if n2 == 1
        fprintf(f_lat,', '); 
    end
    if j == in2-1
        fprintf(f_lat,', %s, %s, %s, &\n    ',char(drift_name_T1_1),char(alldata(list(1,I3(in3)),3)),char(drift_name_T1_2));
    end
    if j == in2
        fprintf(f_lat,' ) \n\n'); 
    end
end

% TL-T2 (: TL-T20)
in1 = 0; n = 0;
for i1 = 1 : a2
    if iscellstr(alldata(list(1,i1),1)) == 1
        if strcmp(char(alldata(list(1,i1),1)),'TL') == 1 || strcmp(char(alldata(list(1,i1),1)),'T20') == 1 || strcmp(char(alldata(list(1,i1),1)),'T2') == 1
            in1 = in1 + 1;
            I1(in1) = i1;
        end
    end
end
in2 = 0;
for i2 = 1 : a2
    if iscellstr(alldata(list(1,i2),1)) == 1
        if strcmp(char(alldata(list(1,i2),1)),'T2') == 1
            in2 = in2 + 1;
            I2(in2) = i2;
        end
    end
end

for j = 1:in1-1
    for k = 1 : a1
        if j == 1 && k == 1
            fprintf(f_lat,'\n%s%s : LINE = ( %s, ',char(alldata(list(1,I1(j)),1)),char(alldata(list(1,I2(j)),1)),char(drift_name_TL_0));
        end
        if j == 2 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_TLD_0));
        elseif j == 3 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_T1TL_1));
        elseif j == 5 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_TL_1));
        elseif j == 6 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_TLT20_1));
        elseif j == 7 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_T20TL_1));
        elseif j == 10 && k == 1
            fprintf(f_lat,'%s, ',char(drift_name_T2));
        end
        if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
            if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
            else
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,4) == 0
                    fprintf(f_lat,'&\n    ');
                end
                n = 0;
            end
        end
    end
    if j < in1-1
        fprintf(f_lat,', '); 
    end
    if j == in1-1
        fprintf(f_lat,' ) \n\n'); 
    end
end


% T3
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T3') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,6) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T4
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T4') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T4D
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T4D') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T5
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T5') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,6) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T5D
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T5D') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
        end
    elseif j == 2
        fprintf(f_lat,'%s, ',char(drift_name_T5D));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        if strcmp(char(alldata(list(k,I1(j)),6)),'SBEN') == 1
                            if cell2mat(alldata(list(k,I1(j)),10)) == 0 || cell2mat(alldata(list(k,I1(j)),11)) == 0
                                arc_len_1 = cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(cell2mat(alldata(list(k,I1(j)),9)));
                            else
                                arc_len_1 = 0.5 * cell2mat(alldata(list(k,I1(j)),8)) * cell2mat(alldata(list(k,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k,I1(j)),9)));
                            end
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - arc_len_1/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        else
                            if strcmp(char(alldata(list(k-1-n,I1(j)),6)),'SBEN') == 1
                                if cell2mat(alldata(list(k-1-n,I1(j)),10)) == 0 || cell2mat(alldata(list(k-1-n,I1(j)),11)) == 0
                                    arc_len_2 = cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                else
                                    arc_len_2 = 0.5 * cell2mat(alldata(list(k-1-n,I1(j)),8)) * cell2mat(alldata(list(k-1-n,I1(j)),9)) / sin(0.5*cell2mat(alldata(list(k-1-n,I1(j)),9)));
                                end
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - arc_len_2/2;
                            else
                                diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                            end
                        end
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T6
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T6') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T7
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T7') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T8
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T8') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T9
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T9') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% T10
in1 = 0; n = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'T10') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if strcmp(char(alldata(list(k,I1(j)),7)),'BENDMARK') == 1
                    n = n + 1;
                else
                    if k > 1
                        diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1-n,I1(j)),13)) - cell2mat(alldata(list(k-1-n,I1(j)),8))/2;
                        if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                            t = find(abs(diff_d-drift_length(1:end))<1e-10);
                            fprintf(f_lat,'%s, ',char(drift_name(t)));
                        end
                    end
                    fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                    if k < a1
                        if list(k+1,I1(j)) ~= 0
                            fprintf(f_lat,', ');
                        end
                    end
                    if mod(k,5) == 0
                        fprintf(f_lat,'&\n    ');
                    end
                    n = 0;
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% SA1
in1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'SA1') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if j == 1 && k == 1
                fprintf(f_lat,'%s, ',char(drift_name_T2SA1_1));
            end
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1,I1(j)),13)) - cell2mat(alldata(list(k-1,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% SA2
in1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'SA2') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1,I1(j)),13)) - cell2mat(alldata(list(k-1,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% SA3
in1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'SA3') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1,I1(j)),13)) - cell2mat(alldata(list(k-1,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% UN1
in1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'UN1') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1,I1(j)),13)) - cell2mat(alldata(list(k-1,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

% UN2
in1 = 0;
for i = 1 : a2
    if iscellstr(alldata(list(1,i),1)) == 1
        if strcmp(char(alldata(list(1,i),1)),'UN2') == 1
            in1 = in1 + 1;
            I1(in1) = i;
        end
    end
end
for j = 1:in1
    if j == 1 
        fprintf(f_lat,'\n%s : LINE = ( ',char(alldata(list(1,I1(j)),1)));
        for k = 1 : a1
            if list(k,I1(j)) > 0 && iscellstr(alldata(list(k,I1(j)))) == 1
                if k > 1
                    diff_d = cell2mat(alldata(list(k,I1(j)),13)) - cell2mat(alldata(list(k,I1(j)),8))/2 - cell2mat(alldata(list(k-1,I1(j)),13)) - cell2mat(alldata(list(k-1,I1(j)),8))/2;
                    if length(find(abs(diff_d-drift_length(1:end))<1e-10)) == 1
                        t = find(abs(diff_d-drift_length(1:end))<1e-10);
                        fprintf(f_lat,'%s, ',char(drift_name(t)));
                    end
                end
                fprintf(f_lat,'%s',char(alldata(list(k,I1(j)),3)));
                if k < a1
                    if list(k+1,I1(j)) ~= 0
                        fprintf(f_lat,', ');
                    end
                end
                if mod(k,5) == 0
                    fprintf(f_lat,'&\n    ');
                end
            end
            if k == a1
                fprintf(f_lat,' ) \n\n'); 
            end
        end            
    end
end

fprintf(f_lat,'\n!XFEL lattice \n');
fprintf(f_lat,'BC : LINE = (L1, B1, L2, B2 ) \n');
fprintf(f_lat,'LIN : LINE = (I1, BC, L3, CL ) \n\n');
fprintf(f_lat,'TD0 : LINE = (TLTLD ) \n');
fprintf(f_lat,'TD1 : LINE = (TLT1, SA2, T3, UN1, T5, UN2, T5D ) \n');
fprintf(f_lat,'TD2 : LINE = (TLT2, SA1, T4, SA3, T4D ) \n');

fprintf(f_lat,'XFEL_TD1 : LINE = (LIN, TD1 ) \n');
fprintf(f_lat,'XFEL_TD2 : LINE = (LIN, TD2 ) \n');

if TD == 1
    fprintf(f_lat,'test : LINE = (LIN, TLT1, SA2, T3, UN1, T5, UN2 ) \n');
elseif TD == 2
    fprintf(f_lat,'test : LINE = (LIN, TLT2, SA1, T4, SA3 ) \n');
end


fclose(f_lat);